// APRS погодная станция v0.24 на базе модуля ESP8266 made in RA4FHE. Выходной формат данных в APRS WX
//http://infotex58.ru

#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include "DHT.h"

#define DHTPIN 2 // Датчик подключаем на GPIO2
#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321 Выбираем тип датчика
//#define DHTTYPE DHT21   // DHT 21 (AM2301)
//#define DHTTYPE DHT11   // DHT 11

ESP8266WiFiMulti WiFiMulti;
DHT dht(DHTPIN, DHTTYPE);

void setup() {
  dht.begin();
  WiFiMulti.addAP("Infotex", "1234"); // Указываем SSID и пароль своего WI-FI роутера
  while (WiFiMulti.run() != WL_CONNECTED)
  {
    delay(500);
  }
}


void loop() {
  const uint16_t port = 14580; // Указываем порт сервера
  const char * host = "194.186.45.251"; // Указываем имя хоста или его IP
  WiFiClient client; // Включаем режим WI-FI клиента
  delay(5000);

  if (!client.connect(host, port)) {
    delay(5000);  // Если приконектились к серверу то едим дальше иначе ждём 5сек
    return;
  }

  client.println("user RA4FHE-2 pass 12345 vers ESP8266_WX 0.24 filter m/1");  // Логинемся на сервер
  delay (250);
  float h = dht.readHumidity();
  float f = dht.readTemperature(true);

  client.print("RA4FHE-2>APRS,TCPIP*,qAC,T2RUSSIA:=5312.66N/04500.72E_");     // Поехали кидать инфу на сервак
  client.print(".../...g...");
  if (f >= 0)
  {
    client.print("t0"); client.print(f , 0);
  }
  else
  {
    client.print("t"); client.print(f , 0);
  }
  client.print("r...p...P...h"); client.print(h, 0);
  client.print("b.....");
  client.println(" Micro APRSWX");
  client.println("RA4FHE-2>APRS,TCPIP*,qAC,T2RUSSIA:> ESP8266 Meteo http://infotex58.ru"); // Статус сообщение
  delay(600000); // Ждём 10 мин перед следующей отправкой пакета 
}
